from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

#A 10-sided rectangular beam enclosure

c = Component()

c.addParameter("batterylength", 35, paramType="length")
c.addParameter("batterywidth", 55, paramType="length") #8
c.addParameter("batterydepth", 31, paramType="length")

c.addSubcomponent("holder", "SimpleRectBeam", inherit=True, prefix=None)
c.addConstraint(("holder", "length"), "batterylength")
c.addConstraint(("holder", "width"), "batterydepth")
c.addConstraint(("holder", "depth"), "batterywidth")

c.addSubcomponent("bottom", "Rectangle", inherit=True)
c.addConstraint(("bottom", "l"), "batterydepth")
c.addConstraint(("bottom", "w"), "batterywidth")
#
c.addConnection(("bottom", "l"), ("holder", "botedge3"), angle=90)
# c.addConnection(("bottom", "l"), ("holder", "botedge1"), tabWidth=10, angle=90)
c.addConnection(("bottom", "r"), ("holder", "botedge1"),tabWidth=15, angle=90)
# c.addConnection(("bottom", "b"), ("holder", "botedge2"), tabWidth=10, angle=90)
#
c.addSubcomponent("top", "Rectangle", inherit=True)
c.addConstraint(("top", "l"), "batterydepth")
c.addConstraint(("top", "w"), "batterywidth")
#
c.addConnection(("top", "l"), ("holder", "topedge3"), angle=90)
# c.addConnection(("top", "l"), ("holder", "topedge1"), tabWidth=10, angle=90)
c.addConnection(("top", "r"), ("holder", "topedge1"),tabWidth=15, angle=90)
# c.addConnection(("top", "b"), ("holder", "topedge2"), tabWidth=10, angle=90)

c.addSubcomponent("cutoutbot", "Cutout")
c.addConstConstraint(("cutoutbot", "dx"), 8)
c.addConstConstraint(("cutoutbot", "dy"), 18)
c.addConnection(("holder", "face0"),
                ("cutoutbot", "decoration"),
                mode="hole")

c.addSubcomponent("cutouttop", "Cutout")
c.addConstConstraint(("cutouttop", "dx"), 8)
c.addConstConstraint(("cutouttop", "dy"), 18)
c.addConnection(("holder", "face2"),
                ("cutouttop", "decoration"),
                mode="hole")

c.toLibrary("BlimpBatteryMount")
