from rocolib.api.components.Component import Component

c = Component()

c.addSubcomponent("front", "NewBrainsTwoWheels")
c.addSubcomponent("back", "TwoWheels")

c.addParameter("length", 65, paramType="length", minValue=65) #tested minValue
c.addParameter("height", 36, paramType="length", minValue=36) #tested minValue
c.addParameter("width", 60, paramType="length", minValue=60) #tested minValue

c.addConstraint(("front", "length"), "length")
c.addConstraint(("front", "height"), "height")
c.addConstraint(("front", "width"), "width")

c.addConstraint(("back", "length"), "length")
c.addConstraint(("back", "height"), "height")
c.addConstraint(("back", "width"), "width")

c.addConnection(("front", "sheath0.botedge2"), ("back", "sheath1.botedge2"))
c.addConnection(("front", "sheath0.botedge0"), ("back", "sheath1.botedge0"), tabWidth=13)

c.addSubcomponent("shield", "Rectangle")
c.addConstraint(("shield", "l"), "height", "x - 13")
c.addConstraint(("shield", "w"), "width")

c.addConnection(("shield", "b"), ("back", "splitedge0"), angle=90, tabWidth=10)
c.addConnection(("shield", "t"), ("back", "splitedge1"), angle=90)

c.toLibrary("FourWheelCar")